#ifndef _FILE_H
#define _FILE_H


//Constants internal definition
#define _FILE_READ    1
#define _FILE_WRITE   2
#define _FILE_APPEND  4
#define _FILE_UPDATE  8
#define _FILE_BINARY  16

#define _FS_UNKNOW    -1
#define _FS_CASIO      0
#define _FS_FAT16      1
#define _FS_STDSTREAMS 2

//Flags :
#define _FILE_WRITTEN 1  //Used for files openned with '+' mode
#define _FILE_READED  2  //Used for files openned with '+' mode
#define _FILE_EOF_REATCHED 4
#define _FILE_BUF_AUTO 8

struct file_operations;

struct _FILE {
	unsigned int pos;
	int open_mode;
	int error;
	int flags;

	int bufsize;
	int cur_bufsize;
	char *buf;
	int iobf_t;

	const struct file_operations *fs_fop; //Pointer to a file_operations struct, that depending of the FS.
	void *private_data; //Pointer to a data structure depending of the FS of the file (may be NULL)
};
//typedef struct _FILE FILE;



#endif //_FILE_H
