#include "stdio.h"
#include "fscasio.h"
#include "file.h"


// All files oppened are referenced in this list :
FILE *__files[FOPEN_MAX] = {0};


FILE *fopen(const char * filename, const char * mode) {
	int i;
	int fval;

	for (i=0; (i<FOPEN_MAX) && ((fval=(int)__files[i])!=0); i++);
	if(fval == 0) {
		if((filename[0]=='\\' && filename[1]=='\\' && filename[2]=='f' && filename[3]=='l' && filename[4]=='s' && filename[5]=='0' && filename[6]=='\\') 
				|| (filename[0]=='/' && filename[1]=='f' && filename[2]=='l' && filename[3]=='s' && filename[4]=='0' && filename[5]=='/')) {
			return fscasio_fopen(filename, mode);
		}
		else if(filename[0]=='\\' && filename[1]=='\\' && filename[2]=='c' && filename[3]=='r' && filename[4]=='d' && filename[5]=='0' && filename[6]=='\\') {
			//return fat16sd_fopen(filename, mode);
		}
		else if(filename[0]=='/' && filename[1]=='d' && filename[2]=='e' && filename[3]=='v' && filename[4]=='/') {
			//return stdstream_fopen(filename, mode);
		}
	}
	return NULL;
}


int fclose(FILE *stream) {
	return stream == NULL ? EOF : stream->fs_fop->fclose(stream);
}

int fgetc(FILE *stream) {
	return stream == NULL ? EOF : stream->fs_fop->fgetc(stream);
}

char *fgets(char * restrict s, int n, FILE * restrict stream) {
	return stream == NULL ? NULL : stream->fs_fop->fgets(s, n, stream);
}


size_t fread(void * restrict ptr, size_t size, size_t nmemb, FILE * restrict stream) {
	return stream == NULL ? 0 : stream->fs_fop->fread(ptr, size, nmemb, stream);
}


int fseek(FILE *stream, long int offset, int whence) {
	return stream == NULL ? -1 : stream->fs_fop->fseek(stream, offset, whence);
}


long int ftell(FILE *stream) {
	return stream == NULL ? -1L : stream->fs_fop->ftell(stream);
}
